#-*- coding: utf-8 -*-

from PyQt5.QtCore import pyqtSignal, QUrl, Qt, QEvent
from PyQt5.QtWebEngineWidgets import (QWebEngineSettings, QWebEngineView, 
                                      QWebEnginePage, )

class WebViewer(QWebEngineView):
    """Define a web page used for the categorie's previews.

    """
    def __init__(self, driver, parent=None):
        super().__init__(parent)
        self.driver = driver
        self.setMouseTracking(False)
        self.page_ = WebPage()
        self.setPage(self.page_)
        self.settings().setAttribute(QWebEngineSettings.PluginsEnabled, True)
        self.loadFinished.connect(self.on_page_loaded)
        self.page_.urlChanged.connect(self.link_clicked)

    def get_page_content(self, url):
        print("Set url: %s" % url)
        self.setUrl(QUrl(url))
        self.url_ = QUrl(url)
    def on_page_loaded(self):
        pass
    def link_clicked(self, url):
        print("New url: %s" % url)

class WebPage(QWebEnginePage):
    def __init__(self, parent=None):
        super().__init__(parent)
        # Obsolete in QWebEngine, see: QWebEnginePage::acceptNavigationRequest()
        #self.LinkDelegationPolicy(QWebEnginePage.DelegateExternalLinks)
        self.settings().setAttribute(
                    QWebEngineSettings.LocalContentCanAccessRemoteUrls, True)
        self.settings().setAttribute(
                    QWebEngineSettings.JavascriptEnabled, True)
        self.is_visible = False


